;*****************************************************************************
;  Read EDU RSR data for the TEB bands to a sav file.
;  
;  v1.0 - 05/27/2008 - Jeff McIntire
;*****************************************************************************

PRO read_rsr

restore,'/home/jmcintire/VIIRS_Data/general.TEB.sav'

inpath='/home/jmcintire/VIIRS_Data/RC_5_EDU/RSR_EDU/'

; Get list of .txt files from specified path. 
spawn, 'ls -C1 ' + inpath + '*.txt', list_files
nfile=N_ELEMENTS(list_files)

rsrf=dblarr(8,3,40*maxdet)

FOR ifile=0, nfile-1 DO BEGIN

	openr,lun,list_files[ifile],/get_lun
	n_lines=File_Lines(list_files[ifile])

	awa=''
	a0=fltarr(n_lines)
	a1=fltarr(n_lines)
	a2=fltarr(n_lines)

	FOR ix=0, n_lines-1 DO BEGIN
		readf,lun,awa
		b1=strsplit(awa,' ',/Extract)
		a0(ix)=b1(1)
		a1(ix)=b1(5)
		a2(ix)=b1(6)
	ENDFOR

	close,lun,/file,/all
	free_lun,lun

	iy=1
	FOR ix=1, n_lines-1 DO BEGIN
		IF a0[ix] GT a0[ix-1] THEN iy=iy+1
	ENDFOR
	iz=n_lines/iy

	c0=fltarr(iz*detectors_TEB[ifile])
	c1=fltarr(iz*detectors_TEB[ifile])
	c2=fltarr(iz*detectors_TEB[ifile])

	FOR id=0, detectors_TEB[ifile]-1 DO BEGIN
		c0[id*iz:iz+id*iz-1]=id
	ENDFOR

	FOR j=0, iy-1 DO BEGIN
		c1[(a0[j*iz]-2)*iz:iz+(a0[j*iz]-2)*iz-1]=a1[j*iz:iz+j*iz-1]
		c1[(a0[j*iz]-1)*iz:iz+(a0[j*iz]-1)*iz-1]=a1[j*iz:iz+j*iz-1]
		c2[(a0[j*iz]-2)*iz:iz+(a0[j*iz]-2)*iz-1]=a2[j*iz:iz+j*iz-1]
		c2[(a0[j*iz]-1)*iz:iz+(a0[j*iz]-1)*iz-1]=a2[j*iz:iz+j*iz-1]
	ENDFOR

	FOR j=0, a0[0]-2 DO BEGIN
		c1[j*iz:iz+j*iz-1]=a1[0:iz-1]
		c2[j*iz:iz+j*iz-1]=a2[0:iz-1]
	ENDFOR
	FOR j=a0[iy*iz-1], detectors_TEB[ifile]-1 DO BEGIN
		c1[j*iz:iz+j*iz-1]=a1[(iy-1)*iz:iy*iz-1]
		c2[j*iz:iz+j*iz-1]=a2[(iy-1)*iz:iy*iz-1]
	ENDFOR

	IF ifile EQ 4 OR ifile EQ 5 THEN BEGIN
		c1[4*iz:iz+4*iz-1]=a1[0:iz-1]
		c2[4*iz:iz+4*iz-1]=a2[0:iz-1]
		c1[5*iz:iz+5*iz-1]=a1[0:iz-1]
		c2[5*iz:iz+5*iz-1]=a2[0:iz-1]
	ENDIF

	FOR id=0, detectors_TEB[ifile]-1 DO BEGIN
		FOR j=0, 39 DO BEGIN
			rsrf[ifile,0,id*40:iz+id*40-1]=c0[id*iz:iz+id*iz-1]
			rsrf[ifile,1,id*40:iz+id*40-1]=c1[id*iz:iz+id*iz-1]
			rsrf[ifile,2,id*40:iz+id*40-1]=c2[id*iz:iz+id*iz-1]
		ENDFOR
	ENDFOR
ENDFOR

save,/compress,rsrf,filename='/home/jmcintire/VIIRS_Code/RC-5/EDU_rsr.sav'

END
